/*
 * $Id: Sort_deallocation.cpp 88 2008-12-10 18:31:39Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Sort/include/Sort.h"

namespace morpheo                    {
namespace behavioural {
namespace generic {
namespace sort {


#undef  FUNCTION
#define FUNCTION "Sort::deallocation"
  void Sort::deallocation (void)
  {
    log_printf(FUNC,Sort,FUNCTION,"Begin");

    if (usage_is_set(_usage,USE_SYSTEMC))
      {
	delete     in_CLOCK ;
	delete     in_NRESET;

	delete []  in_INPUT_VAL   ;
	delete []  in_INPUT_DATA  ;
	delete [] out_OUTPUT_VAL  ;
	if (_param->_have_port_index_out)
	delete [] out_OUTPUT_INDEX;
	if (_param->_have_port_data_out)
	delete [] out_OUTPUT_DATA ;
      }
    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    

    delete _component;

    log_printf(FUNC,Sort,FUNCTION,"End");
  };

}; // end namespace sort
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
